/*****

	Adapted from: http://www.math.ncu.edu.tw/~chenwc/new/myjob/R_note/reference/dfu/oo.htm

	Comile:
	bcc32 -ID:\Ivo.dir\UCLA_Classes\2007\Winter\Stat130D_C_PlusPlus.dir\SourceCode\CPP_R_examples\Example1 -IC:\Borland\BCC55\Include -LC:\Borland\BCC55\Lib -tWD exampleCcallFromR.cpp

	R commands:
	setwd("D:/Ivo.dir/UCLA_Classes/2007/Winter/Stat130D_C_PlusPlus.dir/SourceCode/CPP_R_examples/Example1") 
	dyn.load("exampleCcallFromR.dll")
	is.loaded("_getX")
	is.loaded("_setX")
	is.loaded("_changeSign")

	# Define wrapper functions within R
	setX <- function(a)
	{
		.C("_setX",as.integer(a))
		return()
	}

	getX <- function()
	{
		.C("_getX",as.integer(0))[[1]]
	}

	print(getX())
	print(setX(42))
	print(getX())
	a = 100
	b = .C("_changeSign", as.integer(a))
	c = .C("_intSquareFunction", as.integer(a)) 
	a; b; c		# Print these values

************/

#include <iostream.h>


class X 
{
 public: 
 int n;
};

static X x;

extern "C" __declspec(dllexport) 
void setX(int * a)
{
 x.n = *a;
};

extern "C" __declspec(dllexport) 
void getX(int * a)
{
 *a = x.n;
};
 
extern "C" __declspec(dllexport) 
void changeSign ( int* a)
{	*a = - *a; 	
};

extern "C" __declspec(dllexport) 
void intSquareFunction ( int* a)
{	*a = (*a) * (*a); 	
};

void main(int argc, char* argv[])
{
  int a = 6;
  int b = a;
  changeSign(&b);

  cout << '-' << a << " er " << b << " ! \n";
}