/*****
	http://r.meteo.uni.wroc.pl/src/contrib/Descriptions/RcppTemplate.html
	http://cran.r-project.org/doc/packages/RcppTemplate.pdf

	Ivo Dinov 02/20/2007
	http://www.socr.ucla.edu
	http://www.stat.ucla.edu/%7Edinov/courses_students.dir/07/Winter/STAT130D.dir/STAT130D.html

	Comile:
	bcc32 -ID:\Ivo.dir\UCLA_Classes\2007\Winter\Stat130D_C_PlusPlus.dir\SourceCode\CPP_R_examples\Example1 -IC:\Borland\BCC55\Include -I. -ID:\Ivo.dir\Ivo_Tools\R-2.4.0\include -LD:\Ivo.dir\Ivo_Tools\R-2.4.0\bin -L. -LC:\Borland\BCC55\Lib exampleRcallFromCPP.cpp R.lib

	bcc32 -u- -6 -O2 -WDE -I\R\R-2.3.0\src\include VCrndR.c R.lib

	Linker: Borland has a nice utility tool called implib.exe to create the import library by reading the dll.
	implib -a -f .\R.lib D:\Ivo.dir\Ivo_Tools\R-2.4.0\bin\R.dll

	ilink32.exe exampleRcallFromCPP.obj exampleRcallFromCPP.exec R.lib

	Run Test: exampleRcallFromCPP

************/

#include <iostream.h>
#include <R.h>
#include <Rmath.h>
#include <Random.h>


extern "C" __declspec(dllimport)
double norm_rand ();

extern "C" __declspec(dllimport)
void GetRNGstate();


extern "C" {
#include <R.h>
#include <Rmath.h>
}

void main ()
{
 	cerr << "Start!!!!" << endl;
	
	int Max=100;

	double * arrayUniform;
	double * arrayNormal;
	double * arrayExponential;

	arrayUniform = new double [Max];
	arrayNormal = new double [Max];
	arrayExponential = new double [Max];
	
	//http://www.ugcs.caltech.edu/manuals/math/R-2.2.1-exts/R-exts_86.html
	//GetRNGstate();

	printf("Starting Random Number Generation in R ...\nIndex\tUniform\t\tNormal\t\tExponential\n");
	for (int i=0; i < Max; i++)
	{	arrayUniform[i] = unif_rand();
		arrayNormal[i] = norm_rand();
		arrayExponential[i] = exp_rand();
		cerr << i << "\t" << arrayUniform[i]<< "\t" << arrayNormal[i] << "\t" << arrayExponential[i] << endl;
	}

	//PutRNGstate();

	cerr << "Done!" << endl;
	return;
}
